import java.io.*;
import java.io.IOException;
import java.io.PrintWriter;
import java.io.Writer;
import java.net.MalformedURLException;
import java.net.URL;
import javax.xml.parsers.*;
import org.w3c.dom.*;
import org.xml.sax.*;

/**
 * <b>Choice</b> is generated from chunk_rules.rxm by Relaxer.
 * This class is derived from:
 * 
 * <!-- for programmer
 * <elementRule role="choice">
 *   <ref label="W1" occurs="*"/>
 * </elementRule>
 * 
 * <tag name="choice"/>
 * -->
 * <!-- for javadoc -->
 * <pre> &lt;elementRule role="choice"&gt;
 *   &lt;ref label="W1" occurs="*"/&gt;
 * &lt;/elementRule&gt;
 * &lt;tag name="choice"/&gt;
 * </pre>
 *
 * @version chunk_rules.rxm 1.0 (Fri Jul 25 15:46:44 JST 2003)
 * @author  Relaxer 1.0rc2 (http://www.relaxer.org)
 */
public class Choice implements java.io.Serializable, Cloneable, IOptionalChoice, IZeroOrMoreChoice, IRhsChoice {
    // List<W1>
    private java.util.List w1_ = new java.util.ArrayList();

    /**
     * Creates a <code>Choice</code>.
     *
     */
    public Choice() {
    }

    /**
     * Creates a <code>Choice</code>.
     *
     * @param source
     */
    public Choice(Choice source) {
        setup(source);
    }

    /**
     * Creates a <code>Choice</code> by the Stack <code>stack</code>
     * that contains Elements.
     * This constructor is supposed to be used internally
     * by the Relaxer system.
     *
     * @param stack
     */
    public Choice(RStack stack) {
        setup(stack);
    }

    /**
     * Creates a <code>Choice</code> by the Document <code>doc</code>.
     *
     * @param doc
     */
    public Choice(Document doc) {
        setup(doc.getDocumentElement());
    }

    /**
     * Creates a <code>Choice</code> by the Element <code>element</code>.
     *
     * @param element
     */
    public Choice(Element element) {
        setup(element);
    }

    /**
     * Creates a <code>Choice</code> by the File <code>file</code>.
     *
     * @param file
     * @exception IOException
     * @exception SAXException
     * @exception ParserConfigurationException
     */
    public Choice(File file) throws IOException, SAXException, ParserConfigurationException {
        setup(file);
    }

    /**
     * Creates a <code>Choice</code>
     * by the String representation of URI <code>uri</code>.
     *
     * @param uri
     * @exception IOException
     * @exception SAXException
     * @exception ParserConfigurationException
     */
    public Choice(String uri) throws IOException, SAXException, ParserConfigurationException {
        setup(uri);
    }

    /**
     * Creates a <code>Choice</code> by the URL <code>url</code>.
     *
     * @param url
     * @exception IOException
     * @exception SAXException
     * @exception ParserConfigurationException
     */
    public Choice(URL url) throws IOException, SAXException, ParserConfigurationException {
        setup(url);
    }

    /**
     * Creates a <code>Choice</code> by the InputStream <code>in</code>.
     *
     * @param in
     * @exception IOException
     * @exception SAXException
     * @exception ParserConfigurationException
     */
    public Choice(InputStream in) throws IOException, SAXException, ParserConfigurationException {
        setup(in);
    }

    /**
     * Creates a <code>Choice</code> by the InputSource <code>is</code>.
     *
     * @param is
     * @exception IOException
     * @exception SAXException
     * @exception ParserConfigurationException
     */
    public Choice(InputSource is) throws IOException, SAXException, ParserConfigurationException {
        setup(is);
    }

    /**
     * Creates a <code>Choice</code> by the Reader <code>reader</code>.
     *
     * @param reader
     * @exception IOException
     * @exception SAXException
     * @exception ParserConfigurationException
     */
    public Choice(Reader reader) throws IOException, SAXException, ParserConfigurationException {
        setup(reader);
    }

    /**
     * Initializes the <code>Choice</code> by the Choice <code>source</code>.
     *
     * @param source
     */
    public void setup(Choice source) {
        int size;
        this.w1_.clear();
        size = source.w1_.size();
        for (int i = 0;i < size;i++) {
            addW1((W1)source.getW1(i).clone());
        }
    }

    /**
     * Initializes the <code>Choice</code> by the Document <code>doc</code>.
     *
     * @param doc
     */
    public void setup(Document doc) {
        setup(doc.getDocumentElement());
    }

    /**
     * Initializes the <code>Choice</code> by the Element <code>element</code>.
     *
     * @param element
     */
    public void setup(Element element) {
        init(element);
    }

    /**
     * Initializes the <code>Choice</code> by the Stack <code>stack</code>
     * that contains Elements.
     * This constructor is supposed to be used internally
     * by the Relaxer system.
     *
     * @param stack
     */
    public void setup(RStack stack) {
        init(stack.popElement());
    }

    /**
     * @param element
     */
    private void init(Element element) {
        RStack stack = new RStack(element);
        w1_.clear();
        while (true) {
            if (W1.isMatch(stack)) {
                addW1(new W1(stack));
            } else {
                break;
            }
        }
    }

    /**
     * @return Object
     */
    public Object clone() {
        return (new Choice(this));
    }

    /**
     * Creates a DOM representation of the object.
     * Result is appended to the Node <code>parent</code>.
     *
     * @param parent
     */
    public void makeElement(Node parent) {
        Document doc;
        if (parent instanceof Document) {
            doc = (Document)parent;
        } else {
            doc = parent.getOwnerDocument();
        }
        Element element = doc.createElement("choice");
        int size;
        size = this.w1_.size();
        for (int i = 0;i < size;i++) {
            W1 value = (W1)this.w1_.get(i);
            value.makeElement(element);
        }
        parent.appendChild(element);
    }

    /**
     * Initializes the <code>Choice</code> by the File <code>file</code>.
     *
     * @param file
     * @exception IOException
     * @exception SAXException
     * @exception ParserConfigurationException
     */
    public void setup(File file) throws IOException, SAXException, ParserConfigurationException {
        setup(file.toURL());
    }

    /**
     * Initializes the <code>Choice</code>
     * by the String representation of URI <code>uri</code>.
     *
     * @param uri
     * @exception IOException
     * @exception SAXException
     * @exception ParserConfigurationException
     */
    public void setup(String uri) throws IOException, SAXException, ParserConfigurationException {
        setup(UJAXP.getDocument(uri, UJAXP.FLAG_NONE));
    }

    /**
     * Initializes the <code>Choice</code> by the URL <code>url</code>.
     *
     * @param url
     * @exception IOException
     * @exception SAXException
     * @exception ParserConfigurationException
     */
    public void setup(URL url) throws IOException, SAXException, ParserConfigurationException {
        setup(UJAXP.getDocument(url, UJAXP.FLAG_NONE));
    }

    /**
     * Initializes the <code>Choice</code> by the InputStream <code>in</code>.
     *
     * @param in
     * @exception IOException
     * @exception SAXException
     * @exception ParserConfigurationException
     */
    public void setup(InputStream in) throws IOException, SAXException, ParserConfigurationException {
        setup(UJAXP.getDocument(in, UJAXP.FLAG_NONE));
    }

    /**
     * Initializes the <code>Choice</code> by the InputSource <code>is</code>.
     *
     * @param is
     * @exception IOException
     * @exception SAXException
     * @exception ParserConfigurationException
     */
    public void setup(InputSource is) throws IOException, SAXException, ParserConfigurationException {
        setup(UJAXP.getDocument(is, UJAXP.FLAG_NONE));
    }

    /**
     * Initializes the <code>Choice</code> by the Reader <code>reader</code>.
     *
     * @param reader
     * @exception IOException
     * @exception SAXException
     * @exception ParserConfigurationException
     */
    public void setup(Reader reader) throws IOException, SAXException, ParserConfigurationException {
        setup(UJAXP.getDocument(reader, UJAXP.FLAG_NONE));
    }

    /**
     * Creates a DOM document representation of the object.
     *
     * @exception ParserConfigurationException
     * @return Document
     */
    public Document makeDocument() throws ParserConfigurationException {
        Document doc = UJAXP.makeDocument();
        makeElement(doc);
        return (doc);
    }

    /**
     * Gets the W1 property <b>W1</b>.
     *
     * @return W1[]
     */
    public final W1[] getW1() {
        W1[] array = new W1[w1_.size()];
        return ((W1[])w1_.toArray(array));
    }

    /**
     * Sets the W1 property <b>W1</b>.
     *
     * @param w1
     */
    public final void setW1(W1[] w1) {
        this.w1_.clear();
        for (int i = 0;i < w1.length;i++) {
            addW1(w1[i]);
        }
    }

    /**
     * Sets the W1 property <b>W1</b>.
     *
     * @param w1
     */
    public final void setW1(W1 w1) {
        this.w1_.clear();
        addW1(w1);
    }

    /**
     * Adds the W1 property <b>W1</b>.
     *
     * @param w1
     */
    public final void addW1(W1 w1) {
        this.w1_.add(w1);
    }

    /**
     * Adds the W1 property <b>W1</b>.
     *
     * @param w1
     */
    public final void addW1(W1[] w1) {
        for (int i = 0;i < w1.length;i++) {
            addW1(w1[i]);
        }
    }

    /**
     * Gets number of the W1 property <b>W1</b>.
     *
     * @return int
     */
    public final int sizeW1() {
        return (w1_.size());
    }

    /**
     * Gets the W1 property <b>W1</b> by index.
     *
     * @param index
     * @return W1
     */
    public final W1 getW1(int index) {
        return ((W1)w1_.get(index));
    }

    /**
     * Sets the W1 property <b>W1</b> by index.
     *
     * @param index
     * @param w1
     */
    public final void setW1(int index, W1 w1) {
        this.w1_.set(index, w1);
    }

    /**
     * Adds the W1 property <b>W1</b> by index.
     *
     * @param index
     * @param w1
     */
    public final void addW1(int index, W1 w1) {
        this.w1_.add(index, w1);
    }

    /**
     * Remove the W1 property <b>W1</b> by index.
     *
     * @param index
     */
    public final void removeW1(int index) {
        this.w1_.remove(index);
    }

    /**
     * Remove the W1 property <b>W1</b> by object.
     *
     * @param w1
     */
    public final void removeW1(W1 w1) {
        this.w1_.remove(w1);
    }

    /**
     * Clear the W1 property <b>W1</b>.
     *
     */
    public final void clearW1() {
        this.w1_.clear();
    }

    /**
     * Makes a XML text representation.
     *
     * @return String
     */
    public String makeTextDocument() {
        StringBuffer buffer = new StringBuffer();
        makeTextElement(buffer);
        return (new String(buffer));
    }

    /**
     * Makes a XML text representation.
     *
     * @param buffer
     */
    public void makeTextElement(StringBuffer buffer) {
        int size;
        buffer.append("<choice");
        buffer.append(">");
        size = this.w1_.size();
        for (int i = 0;i < size;i++) {
            W1 value = (W1)this.w1_.get(i);
            value.makeTextElement(buffer);
        }
        buffer.append("</choice>");
    }

    /**
     * Makes a XML text representation.
     *
     * @param buffer
     * @exception IOException
     */
    public void makeTextElement(Writer buffer) throws IOException {
        int size;
        buffer.write("<choice");
        buffer.write(">");
        size = this.w1_.size();
        for (int i = 0;i < size;i++) {
            W1 value = (W1)this.w1_.get(i);
            value.makeTextElement(buffer);
        }
        buffer.write("</choice>");
    }

    /**
     * Makes a XML text representation.
     *
     * @param buffer
     */
    public void makeTextElement(PrintWriter buffer) {
        int size;
        buffer.print("<choice");
        buffer.print(">");
        size = this.w1_.size();
        for (int i = 0;i < size;i++) {
            W1 value = (W1)this.w1_.get(i);
            value.makeTextElement(buffer);
        }
        buffer.print("</choice>");
    }

    /**
     * Makes a XML text representation.
     *
     * @param buffer
     */
    public void makeTextAttribute(StringBuffer buffer) {
    }

    /**
     * Makes a XML text representation.
     *
     * @param buffer
     * @exception IOException
     */
    public void makeTextAttribute(Writer buffer) throws IOException {
    }

    /**
     * Makes a XML text representation.
     *
     * @param buffer
     */
    public void makeTextAttribute(PrintWriter buffer) {
    }

    /**
     * Returns a String representation of this object.
     * While this method informs as XML format representaion, 
     *  it's purpose is just information, not making 
     * a rigid XML documentation.
     *
     * @return String
     */
    public String toString() {
        try {
            return (makeTextDocument());
        } catch (Exception e) {
            return (super.toString());
        }
    }

    /**
     * Tests if a Element <code>element</code> is valid
     * for the <code>Choice</code>.
     *
     * @param element
     * @return boolean
     */
    public static boolean isMatch(Element element) {
        if (!URelaxer.isTargetElement(element, "choice")) {
            return (false);
        }
        RStack target = new RStack(element);
        boolean $match$ = false;
        Element child;
        while (true) {
            if (!W1.isMatchHungry(target)) {
                break;
            }
            $match$ = true;
        }
        if (!target.isEmptyElement()) {
            return (false);
        }
        return (true);
    }

    /**
     * Tests if elements contained in a Stack <code>stack</code>
     * is valid for the <code>Choice</code>.
     * This mehtod is supposed to be used internally
     * by the Relaxer system.
     *
     * @param stack
     * @return boolean
     */
    public static boolean isMatch(RStack stack) {
        Element element = stack.peekElement();
        if (element == null) {
            return (false);
        }
        return (isMatch(element));
    }

    /**
     * Tests if elements contained in a Stack <code>stack</code>
     * is valid for the <code>Choice</code>.
     * This method consumes the stack contents during matching operation.
     * This mehtod is supposed to be used internally
     * by the Relaxer system.
     *
     * @param stack
     * @return boolean
     */
    public static boolean isMatchHungry(RStack stack) {
        Element element = stack.peekElement();
        if (element == null) {
            return (false);
        }
        if (isMatch(element)) {
            stack.popElement();
            return (true);
        } else {
            return (false);
        }
    }
}
