import java.io.*;
import java.io.IOException;
import java.io.PrintWriter;
import java.io.Writer;
import java.net.MalformedURLException;
import java.net.URL;
import javax.xml.parsers.*;
import org.w3c.dom.*;
import org.xml.sax.*;

/**
 * <b>ChunkRules</b> is generated from chunk_rules.rxm by Relaxer.
 * This class is derived from:
 * 
 * <!-- for programmer
 * <elementRule role="chunk_rules">
 *   <ref label="rule" occurs="*"/>
 * </elementRule>
 * 
 * <tag name="chunk_rules"/>
 * -->
 * <!-- for javadoc -->
 * <pre> &lt;elementRule role="chunk_rules"&gt;
 *   &lt;ref label="rule" occurs="*"/&gt;
 * &lt;/elementRule&gt;
 * &lt;tag name="chunk_rules"/&gt;
 * </pre>
 *
 * @version chunk_rules.rxm 1.0 (Fri Jul 25 15:46:44 JST 2003)
 * @author  Relaxer 1.0rc2 (http://www.relaxer.org)
 */
public class ChunkRules implements java.io.Serializable, Cloneable {
    // List<Rule>
    private java.util.List rule_ = new java.util.ArrayList();

    /**
     * Creates a <code>ChunkRules</code>.
     *
     */
    public ChunkRules() {
    }

    /**
     * Creates a <code>ChunkRules</code>.
     *
     * @param source
     */
    public ChunkRules(ChunkRules source) {
        setup(source);
    }

    /**
     * Creates a <code>ChunkRules</code> by the Stack <code>stack</code>
     * that contains Elements.
     * This constructor is supposed to be used internally
     * by the Relaxer system.
     *
     * @param stack
     */
    public ChunkRules(RStack stack) {
        setup(stack);
    }

    /**
     * Creates a <code>ChunkRules</code> by the Document <code>doc</code>.
     *
     * @param doc
     */
    public ChunkRules(Document doc) {
        setup(doc.getDocumentElement());
    }

    /**
     * Creates a <code>ChunkRules</code> by the Element <code>element</code>.
     *
     * @param element
     */
    public ChunkRules(Element element) {
        setup(element);
    }

    /**
     * Creates a <code>ChunkRules</code> by the File <code>file</code>.
     *
     * @param file
     * @exception IOException
     * @exception SAXException
     * @exception ParserConfigurationException
     */
    public ChunkRules(File file) throws IOException, SAXException, ParserConfigurationException {
        setup(file);
    }

    /**
     * Creates a <code>ChunkRules</code>
     * by the String representation of URI <code>uri</code>.
     *
     * @param uri
     * @exception IOException
     * @exception SAXException
     * @exception ParserConfigurationException
     */
    public ChunkRules(String uri) throws IOException, SAXException, ParserConfigurationException {
        setup(uri);
    }

    /**
     * Creates a <code>ChunkRules</code> by the URL <code>url</code>.
     *
     * @param url
     * @exception IOException
     * @exception SAXException
     * @exception ParserConfigurationException
     */
    public ChunkRules(URL url) throws IOException, SAXException, ParserConfigurationException {
        setup(url);
    }

    /**
     * Creates a <code>ChunkRules</code> by the InputStream <code>in</code>.
     *
     * @param in
     * @exception IOException
     * @exception SAXException
     * @exception ParserConfigurationException
     */
    public ChunkRules(InputStream in) throws IOException, SAXException, ParserConfigurationException {
        setup(in);
    }

    /**
     * Creates a <code>ChunkRules</code> by the InputSource <code>is</code>.
     *
     * @param is
     * @exception IOException
     * @exception SAXException
     * @exception ParserConfigurationException
     */
    public ChunkRules(InputSource is) throws IOException, SAXException, ParserConfigurationException {
        setup(is);
    }

    /**
     * Creates a <code>ChunkRules</code> by the Reader <code>reader</code>.
     *
     * @param reader
     * @exception IOException
     * @exception SAXException
     * @exception ParserConfigurationException
     */
    public ChunkRules(Reader reader) throws IOException, SAXException, ParserConfigurationException {
        setup(reader);
    }

    /**
     * Initializes the <code>ChunkRules</code> by the ChunkRules <code>source</code>.
     *
     * @param source
     */
    public void setup(ChunkRules source) {
        int size;
        this.rule_.clear();
        size = source.rule_.size();
        for (int i = 0;i < size;i++) {
            addRule((Rule)source.getRule(i).clone());
        }
    }

    /**
     * Initializes the <code>ChunkRules</code> by the Document <code>doc</code>.
     *
     * @param doc
     */
    public void setup(Document doc) {
        setup(doc.getDocumentElement());
    }

    /**
     * Initializes the <code>ChunkRules</code> by the Element <code>element</code>.
     *
     * @param element
     */
    public void setup(Element element) {
        init(element);
    }

    /**
     * Initializes the <code>ChunkRules</code> by the Stack <code>stack</code>
     * that contains Elements.
     * This constructor is supposed to be used internally
     * by the Relaxer system.
     *
     * @param stack
     */
    public void setup(RStack stack) {
        init(stack.popElement());
    }

    /**
     * @param element
     */
    private void init(Element element) {
        RStack stack = new RStack(element);
        rule_.clear();
        while (true) {
            if (Rule.isMatch(stack)) {
                addRule(new Rule(stack));
            } else {
                break;
            }
        }
    }

    /**
     * @return Object
     */
    public Object clone() {
        return (new ChunkRules(this));
    }

    /**
     * Creates a DOM representation of the object.
     * Result is appended to the Node <code>parent</code>.
     *
     * @param parent
     */
    public void makeElement(Node parent) {
        Document doc;
        if (parent instanceof Document) {
            doc = (Document)parent;
        } else {
            doc = parent.getOwnerDocument();
        }
        Element element = doc.createElement("chunk_rules");
        int size;
        size = this.rule_.size();
        for (int i = 0;i < size;i++) {
            Rule value = (Rule)this.rule_.get(i);
            value.makeElement(element);
        }
        parent.appendChild(element);
    }

    /**
     * Initializes the <code>ChunkRules</code> by the File <code>file</code>.
     *
     * @param file
     * @exception IOException
     * @exception SAXException
     * @exception ParserConfigurationException
     */
    public void setup(File file) throws IOException, SAXException, ParserConfigurationException {
        setup(file.toURL());
    }

    /**
     * Initializes the <code>ChunkRules</code>
     * by the String representation of URI <code>uri</code>.
     *
     * @param uri
     * @exception IOException
     * @exception SAXException
     * @exception ParserConfigurationException
     */
    public void setup(String uri) throws IOException, SAXException, ParserConfigurationException {
        setup(UJAXP.getDocument(uri, UJAXP.FLAG_NONE));
    }

    /**
     * Initializes the <code>ChunkRules</code> by the URL <code>url</code>.
     *
     * @param url
     * @exception IOException
     * @exception SAXException
     * @exception ParserConfigurationException
     */
    public void setup(URL url) throws IOException, SAXException, ParserConfigurationException {
        setup(UJAXP.getDocument(url, UJAXP.FLAG_NONE));
    }

    /**
     * Initializes the <code>ChunkRules</code> by the InputStream <code>in</code>.
     *
     * @param in
     * @exception IOException
     * @exception SAXException
     * @exception ParserConfigurationException
     */
    public void setup(InputStream in) throws IOException, SAXException, ParserConfigurationException {
        setup(UJAXP.getDocument(in, UJAXP.FLAG_NONE));
    }

    /**
     * Initializes the <code>ChunkRules</code> by the InputSource <code>is</code>.
     *
     * @param is
     * @exception IOException
     * @exception SAXException
     * @exception ParserConfigurationException
     */
    public void setup(InputSource is) throws IOException, SAXException, ParserConfigurationException {
        setup(UJAXP.getDocument(is, UJAXP.FLAG_NONE));
    }

    /**
     * Initializes the <code>ChunkRules</code> by the Reader <code>reader</code>.
     *
     * @param reader
     * @exception IOException
     * @exception SAXException
     * @exception ParserConfigurationException
     */
    public void setup(Reader reader) throws IOException, SAXException, ParserConfigurationException {
        setup(UJAXP.getDocument(reader, UJAXP.FLAG_NONE));
    }

    /**
     * Creates a DOM document representation of the object.
     *
     * @exception ParserConfigurationException
     * @return Document
     */
    public Document makeDocument() throws ParserConfigurationException {
        Document doc = UJAXP.makeDocument();
        makeElement(doc);
        return (doc);
    }

    /**
     * Gets the Rule property <b>rule</b>.
     *
     * @return Rule[]
     */
    public final Rule[] getRule() {
        Rule[] array = new Rule[rule_.size()];
        return ((Rule[])rule_.toArray(array));
    }

    /**
     * Sets the Rule property <b>rule</b>.
     *
     * @param rule
     */
    public final void setRule(Rule[] rule) {
        this.rule_.clear();
        for (int i = 0;i < rule.length;i++) {
            addRule(rule[i]);
        }
    }

    /**
     * Sets the Rule property <b>rule</b>.
     *
     * @param rule
     */
    public final void setRule(Rule rule) {
        this.rule_.clear();
        addRule(rule);
    }

    /**
     * Adds the Rule property <b>rule</b>.
     *
     * @param rule
     */
    public final void addRule(Rule rule) {
        this.rule_.add(rule);
    }

    /**
     * Adds the Rule property <b>rule</b>.
     *
     * @param rule
     */
    public final void addRule(Rule[] rule) {
        for (int i = 0;i < rule.length;i++) {
            addRule(rule[i]);
        }
    }

    /**
     * Gets number of the Rule property <b>rule</b>.
     *
     * @return int
     */
    public final int sizeRule() {
        return (rule_.size());
    }

    /**
     * Gets the Rule property <b>rule</b> by index.
     *
     * @param index
     * @return Rule
     */
    public final Rule getRule(int index) {
        return ((Rule)rule_.get(index));
    }

    /**
     * Sets the Rule property <b>rule</b> by index.
     *
     * @param index
     * @param rule
     */
    public final void setRule(int index, Rule rule) {
        this.rule_.set(index, rule);
    }

    /**
     * Adds the Rule property <b>rule</b> by index.
     *
     * @param index
     * @param rule
     */
    public final void addRule(int index, Rule rule) {
        this.rule_.add(index, rule);
    }

    /**
     * Remove the Rule property <b>rule</b> by index.
     *
     * @param index
     */
    public final void removeRule(int index) {
        this.rule_.remove(index);
    }

    /**
     * Remove the Rule property <b>rule</b> by object.
     *
     * @param rule
     */
    public final void removeRule(Rule rule) {
        this.rule_.remove(rule);
    }

    /**
     * Clear the Rule property <b>rule</b>.
     *
     */
    public final void clearRule() {
        this.rule_.clear();
    }

    /**
     * Makes a XML text representation.
     *
     * @return String
     */
    public String makeTextDocument() {
        StringBuffer buffer = new StringBuffer();
        makeTextElement(buffer);
        return (new String(buffer));
    }

    /**
     * Makes a XML text representation.
     *
     * @param buffer
     */
    public void makeTextElement(StringBuffer buffer) {
        int size;
        buffer.append("<chunk_rules");
        buffer.append(">");
        size = this.rule_.size();
        for (int i = 0;i < size;i++) {
            Rule value = (Rule)this.rule_.get(i);
            value.makeTextElement(buffer);
        }
        buffer.append("</chunk_rules>");
    }

    /**
     * Makes a XML text representation.
     *
     * @param buffer
     * @exception IOException
     */
    public void makeTextElement(Writer buffer) throws IOException {
        int size;
        buffer.write("<chunk_rules");
        buffer.write(">");
        size = this.rule_.size();
        for (int i = 0;i < size;i++) {
            Rule value = (Rule)this.rule_.get(i);
            value.makeTextElement(buffer);
        }
        buffer.write("</chunk_rules>");
    }

    /**
     * Makes a XML text representation.
     *
     * @param buffer
     */
    public void makeTextElement(PrintWriter buffer) {
        int size;
        buffer.print("<chunk_rules");
        buffer.print(">");
        size = this.rule_.size();
        for (int i = 0;i < size;i++) {
            Rule value = (Rule)this.rule_.get(i);
            value.makeTextElement(buffer);
        }
        buffer.print("</chunk_rules>");
    }

    /**
     * Makes a XML text representation.
     *
     * @param buffer
     */
    public void makeTextAttribute(StringBuffer buffer) {
    }

    /**
     * Makes a XML text representation.
     *
     * @param buffer
     * @exception IOException
     */
    public void makeTextAttribute(Writer buffer) throws IOException {
    }

    /**
     * Makes a XML text representation.
     *
     * @param buffer
     */
    public void makeTextAttribute(PrintWriter buffer) {
    }

    /**
     * Returns a String representation of this object.
     * While this method informs as XML format representaion, 
     *  it's purpose is just information, not making 
     * a rigid XML documentation.
     *
     * @return String
     */
    public String toString() {
        try {
            return (makeTextDocument());
        } catch (Exception e) {
            return (super.toString());
        }
    }

    /**
     * Tests if a Element <code>element</code> is valid
     * for the <code>ChunkRules</code>.
     *
     * @param element
     * @return boolean
     */
    public static boolean isMatch(Element element) {
        if (!URelaxer.isTargetElement(element, "chunk_rules")) {
            return (false);
        }
        RStack target = new RStack(element);
        boolean $match$ = false;
        Element child;
        while (true) {
            if (!Rule.isMatchHungry(target)) {
                break;
            }
            $match$ = true;
        }
        if (!target.isEmptyElement()) {
            return (false);
        }
        return (true);
    }

    /**
     * Tests if elements contained in a Stack <code>stack</code>
     * is valid for the <code>ChunkRules</code>.
     * This mehtod is supposed to be used internally
     * by the Relaxer system.
     *
     * @param stack
     * @return boolean
     */
    public static boolean isMatch(RStack stack) {
        Element element = stack.peekElement();
        if (element == null) {
            return (false);
        }
        return (isMatch(element));
    }

    /**
     * Tests if elements contained in a Stack <code>stack</code>
     * is valid for the <code>ChunkRules</code>.
     * This method consumes the stack contents during matching operation.
     * This mehtod is supposed to be used internally
     * by the Relaxer system.
     *
     * @param stack
     * @return boolean
     */
    public static boolean isMatchHungry(RStack stack) {
        Element element = stack.peekElement();
        if (element == null) {
            return (false);
        }
        if (isMatch(element)) {
            stack.popElement();
            return (true);
        } else {
            return (false);
        }
    }
}
