import java.io.*;
import java.io.IOException;
import java.io.PrintWriter;
import java.io.Writer;
import java.net.MalformedURLException;
import java.net.URL;
import javax.xml.parsers.*;
import org.w3c.dom.*;
import org.xml.sax.*;

/**
 * <b>Rhs</b> is generated from chunk_rules.rxm by Relaxer.
 * This class is derived from:
 * 
 * <!-- for programmer
 * <elementRule role="rhs">
 *   <choice occurs="*">
 *     <ref label="optional"/>
 *     <ref label="zeroOrMore"/>
 *     <ref label="choice"/>
 *     <ref label="W1"/>
 *   </choice>
 * </elementRule>
 * 
 * <tag name="rhs"/>
 * -->
 * <!-- for javadoc -->
 * <pre> &lt;elementRule role="rhs"&gt;
 *   &lt;choice occurs="*"&gt;
 *     &lt;ref label="optional"/&gt;
 *     &lt;ref label="zeroOrMore"/&gt;
 *     &lt;ref label="choice"/&gt;
 *     &lt;ref label="W1"/&gt;
 *   &lt;/choice&gt;
 * &lt;/elementRule&gt;
 * &lt;tag name="rhs"/&gt;
 * </pre>
 *
 * @version chunk_rules.rxm 1.0 (Fri Jul 25 15:46:44 JST 2003)
 * @author  Relaxer 1.0rc2 (http://www.relaxer.org)
 */
public class Rhs implements java.io.Serializable, Cloneable {
    // List<IRhsChoice>
    private java.util.List content_ = new java.util.ArrayList();

    /**
     * Creates a <code>Rhs</code>.
     *
     */
    public Rhs() {
    }

    /**
     * Creates a <code>Rhs</code>.
     *
     * @param source
     */
    public Rhs(Rhs source) {
        setup(source);
    }

    /**
     * Creates a <code>Rhs</code> by the Stack <code>stack</code>
     * that contains Elements.
     * This constructor is supposed to be used internally
     * by the Relaxer system.
     *
     * @param stack
     */
    public Rhs(RStack stack) {
        setup(stack);
    }

    /**
     * Creates a <code>Rhs</code> by the Document <code>doc</code>.
     *
     * @param doc
     */
    public Rhs(Document doc) {
        setup(doc.getDocumentElement());
    }

    /**
     * Creates a <code>Rhs</code> by the Element <code>element</code>.
     *
     * @param element
     */
    public Rhs(Element element) {
        setup(element);
    }

    /**
     * Creates a <code>Rhs</code> by the File <code>file</code>.
     *
     * @param file
     * @exception IOException
     * @exception SAXException
     * @exception ParserConfigurationException
     */
    public Rhs(File file) throws IOException, SAXException, ParserConfigurationException {
        setup(file);
    }

    /**
     * Creates a <code>Rhs</code>
     * by the String representation of URI <code>uri</code>.
     *
     * @param uri
     * @exception IOException
     * @exception SAXException
     * @exception ParserConfigurationException
     */
    public Rhs(String uri) throws IOException, SAXException, ParserConfigurationException {
        setup(uri);
    }

    /**
     * Creates a <code>Rhs</code> by the URL <code>url</code>.
     *
     * @param url
     * @exception IOException
     * @exception SAXException
     * @exception ParserConfigurationException
     */
    public Rhs(URL url) throws IOException, SAXException, ParserConfigurationException {
        setup(url);
    }

    /**
     * Creates a <code>Rhs</code> by the InputStream <code>in</code>.
     *
     * @param in
     * @exception IOException
     * @exception SAXException
     * @exception ParserConfigurationException
     */
    public Rhs(InputStream in) throws IOException, SAXException, ParserConfigurationException {
        setup(in);
    }

    /**
     * Creates a <code>Rhs</code> by the InputSource <code>is</code>.
     *
     * @param is
     * @exception IOException
     * @exception SAXException
     * @exception ParserConfigurationException
     */
    public Rhs(InputSource is) throws IOException, SAXException, ParserConfigurationException {
        setup(is);
    }

    /**
     * Creates a <code>Rhs</code> by the Reader <code>reader</code>.
     *
     * @param reader
     * @exception IOException
     * @exception SAXException
     * @exception ParserConfigurationException
     */
    public Rhs(Reader reader) throws IOException, SAXException, ParserConfigurationException {
        setup(reader);
    }

    /**
     * Initializes the <code>Rhs</code> by the Rhs <code>source</code>.
     *
     * @param source
     */
    public void setup(Rhs source) {
        int size;
        this.content_.clear();
        size = source.content_.size();
        for (int i = 0;i < size;i++) {
            addContent((IRhsChoice)source.getContent(i).clone());
        }
    }

    /**
     * Initializes the <code>Rhs</code> by the Document <code>doc</code>.
     *
     * @param doc
     */
    public void setup(Document doc) {
        setup(doc.getDocumentElement());
    }

    /**
     * Initializes the <code>Rhs</code> by the Element <code>element</code>.
     *
     * @param element
     */
    public void setup(Element element) {
        init(element);
    }

    /**
     * Initializes the <code>Rhs</code> by the Stack <code>stack</code>
     * that contains Elements.
     * This constructor is supposed to be used internally
     * by the Relaxer system.
     *
     * @param stack
     */
    public void setup(RStack stack) {
        init(stack.popElement());
    }

    /**
     * @param element
     */
    private void init(Element element) {
        RStack stack = new RStack(element);
        content_.clear();
        while (true) {
            if (Optional.isMatch(stack)) {
                addContent(new Optional(stack));
            } else if (ZeroOrMore.isMatch(stack)) {
                addContent(new ZeroOrMore(stack));
            } else if (W1.isMatch(stack)) {
                addContent(new W1(stack));
            } else if (Choice.isMatch(stack)) {
                addContent(new Choice(stack));
            } else {
                break;
            }
        }
    }

    /**
     * @return Object
     */
    public Object clone() {
        return (new Rhs(this));
    }

    /**
     * Creates a DOM representation of the object.
     * Result is appended to the Node <code>parent</code>.
     *
     * @param parent
     */
    public void makeElement(Node parent) {
        Document doc;
        if (parent instanceof Document) {
            doc = (Document)parent;
        } else {
            doc = parent.getOwnerDocument();
        }
        Element element = doc.createElement("rhs");
        int size;
        size = this.content_.size();
        for (int i = 0;i < size;i++) {
            IRhsChoice value = (IRhsChoice)this.content_.get(i);
            value.makeElement(element);
        }
        parent.appendChild(element);
    }

    /**
     * Initializes the <code>Rhs</code> by the File <code>file</code>.
     *
     * @param file
     * @exception IOException
     * @exception SAXException
     * @exception ParserConfigurationException
     */
    public void setup(File file) throws IOException, SAXException, ParserConfigurationException {
        setup(file.toURL());
    }

    /**
     * Initializes the <code>Rhs</code>
     * by the String representation of URI <code>uri</code>.
     *
     * @param uri
     * @exception IOException
     * @exception SAXException
     * @exception ParserConfigurationException
     */
    public void setup(String uri) throws IOException, SAXException, ParserConfigurationException {
        setup(UJAXP.getDocument(uri, UJAXP.FLAG_NONE));
    }

    /**
     * Initializes the <code>Rhs</code> by the URL <code>url</code>.
     *
     * @param url
     * @exception IOException
     * @exception SAXException
     * @exception ParserConfigurationException
     */
    public void setup(URL url) throws IOException, SAXException, ParserConfigurationException {
        setup(UJAXP.getDocument(url, UJAXP.FLAG_NONE));
    }

    /**
     * Initializes the <code>Rhs</code> by the InputStream <code>in</code>.
     *
     * @param in
     * @exception IOException
     * @exception SAXException
     * @exception ParserConfigurationException
     */
    public void setup(InputStream in) throws IOException, SAXException, ParserConfigurationException {
        setup(UJAXP.getDocument(in, UJAXP.FLAG_NONE));
    }

    /**
     * Initializes the <code>Rhs</code> by the InputSource <code>is</code>.
     *
     * @param is
     * @exception IOException
     * @exception SAXException
     * @exception ParserConfigurationException
     */
    public void setup(InputSource is) throws IOException, SAXException, ParserConfigurationException {
        setup(UJAXP.getDocument(is, UJAXP.FLAG_NONE));
    }

    /**
     * Initializes the <code>Rhs</code> by the Reader <code>reader</code>.
     *
     * @param reader
     * @exception IOException
     * @exception SAXException
     * @exception ParserConfigurationException
     */
    public void setup(Reader reader) throws IOException, SAXException, ParserConfigurationException {
        setup(UJAXP.getDocument(reader, UJAXP.FLAG_NONE));
    }

    /**
     * Creates a DOM document representation of the object.
     *
     * @exception ParserConfigurationException
     * @return Document
     */
    public Document makeDocument() throws ParserConfigurationException {
        Document doc = UJAXP.makeDocument();
        makeElement(doc);
        return (doc);
    }

    /**
     * Gets the IRhsChoice property <b>content</b>.
     *
     * @return IRhsChoice[]
     */
    public final IRhsChoice[] getContent() {
        IRhsChoice[] array = new IRhsChoice[content_.size()];
        return ((IRhsChoice[])content_.toArray(array));
    }

    /**
     * Sets the IRhsChoice property <b>content</b>.
     *
     * @param content
     */
    public final void setContent(IRhsChoice[] content) {
        this.content_.clear();
        for (int i = 0;i < content.length;i++) {
            addContent(content[i]);
        }
    }

    /**
     * Sets the IRhsChoice property <b>content</b>.
     *
     * @param content
     */
    public final void setContent(IRhsChoice content) {
        this.content_.clear();
        addContent(content);
    }

    /**
     * Adds the IRhsChoice property <b>content</b>.
     *
     * @param content
     */
    public final void addContent(IRhsChoice content) {
        this.content_.add(content);
    }

    /**
     * Adds the IRhsChoice property <b>content</b>.
     *
     * @param content
     */
    public final void addContent(IRhsChoice[] content) {
        for (int i = 0;i < content.length;i++) {
            addContent(content[i]);
        }
    }

    /**
     * Gets number of the IRhsChoice property <b>content</b>.
     *
     * @return int
     */
    public final int sizeContent() {
        return (content_.size());
    }

    /**
     * Gets the IRhsChoice property <b>content</b> by index.
     *
     * @param index
     * @return IRhsChoice
     */
    public final IRhsChoice getContent(int index) {
        return ((IRhsChoice)content_.get(index));
    }

    /**
     * Sets the IRhsChoice property <b>content</b> by index.
     *
     * @param index
     * @param content
     */
    public final void setContent(int index, IRhsChoice content) {
        this.content_.set(index, content);
    }

    /**
     * Adds the IRhsChoice property <b>content</b> by index.
     *
     * @param index
     * @param content
     */
    public final void addContent(int index, IRhsChoice content) {
        this.content_.add(index, content);
    }

    /**
     * Remove the IRhsChoice property <b>content</b> by index.
     *
     * @param index
     */
    public final void removeContent(int index) {
        this.content_.remove(index);
    }

    /**
     * Remove the IRhsChoice property <b>content</b> by object.
     *
     * @param content
     */
    public final void removeContent(IRhsChoice content) {
        this.content_.remove(content);
    }

    /**
     * Clear the IRhsChoice property <b>content</b>.
     *
     */
    public final void clearContent() {
        this.content_.clear();
    }

    /**
     * Makes a XML text representation.
     *
     * @return String
     */
    public String makeTextDocument() {
        StringBuffer buffer = new StringBuffer();
        makeTextElement(buffer);
        return (new String(buffer));
    }

    /**
     * Makes a XML text representation.
     *
     * @param buffer
     */
    public void makeTextElement(StringBuffer buffer) {
        int size;
        buffer.append("<rhs");
        size = this.content_.size();
        for (int i = 0;i < size;i++) {
            IRhsChoice value = (IRhsChoice)this.content_.get(i);
            value.makeTextAttribute(buffer);
        }
        buffer.append(">");
        size = this.content_.size();
        for (int i = 0;i < size;i++) {
            IRhsChoice value = (IRhsChoice)this.content_.get(i);
            value.makeTextElement(buffer);
        }
        buffer.append("</rhs>");
    }

    /**
     * Makes a XML text representation.
     *
     * @param buffer
     * @exception IOException
     */
    public void makeTextElement(Writer buffer) throws IOException {
        int size;
        buffer.write("<rhs");
        size = this.content_.size();
        for (int i = 0;i < size;i++) {
            IRhsChoice value = (IRhsChoice)this.content_.get(i);
            value.makeTextAttribute(buffer);
        }
        buffer.write(">");
        size = this.content_.size();
        for (int i = 0;i < size;i++) {
            IRhsChoice value = (IRhsChoice)this.content_.get(i);
            value.makeTextElement(buffer);
        }
        buffer.write("</rhs>");
    }

    /**
     * Makes a XML text representation.
     *
     * @param buffer
     */
    public void makeTextElement(PrintWriter buffer) {
        int size;
        buffer.print("<rhs");
        size = this.content_.size();
        for (int i = 0;i < size;i++) {
            IRhsChoice value = (IRhsChoice)this.content_.get(i);
            value.makeTextAttribute(buffer);
        }
        buffer.print(">");
        size = this.content_.size();
        for (int i = 0;i < size;i++) {
            IRhsChoice value = (IRhsChoice)this.content_.get(i);
            value.makeTextElement(buffer);
        }
        buffer.print("</rhs>");
    }

    /**
     * Makes a XML text representation.
     *
     * @param buffer
     */
    public void makeTextAttribute(StringBuffer buffer) {
    }

    /**
     * Makes a XML text representation.
     *
     * @param buffer
     * @exception IOException
     */
    public void makeTextAttribute(Writer buffer) throws IOException {
    }

    /**
     * Makes a XML text representation.
     *
     * @param buffer
     */
    public void makeTextAttribute(PrintWriter buffer) {
    }

    /**
     * Returns a String representation of this object.
     * While this method informs as XML format representaion, 
     *  it's purpose is just information, not making 
     * a rigid XML documentation.
     *
     * @return String
     */
    public String toString() {
        try {
            return (makeTextDocument());
        } catch (Exception e) {
            return (super.toString());
        }
    }

    /**
     * Tests if a Element <code>element</code> is valid
     * for the <code>Rhs</code>.
     *
     * @param element
     * @return boolean
     */
    public static boolean isMatch(Element element) {
        if (!URelaxer.isTargetElement(element, "rhs")) {
            return (false);
        }
        RStack target = new RStack(element);
        boolean $match$ = false;
        Element child;
        while (true) {
            if (Optional.isMatchHungry(target)) {
                $match$ = true;
            } else if (ZeroOrMore.isMatchHungry(target)) {
                $match$ = true;
            } else if (W1.isMatchHungry(target)) {
                $match$ = true;
            } else if (Choice.isMatchHungry(target)) {
                $match$ = true;
            } else {
                break;
            }
        }
        if (!target.isEmptyElement()) {
            return (false);
        }
        return (true);
    }

    /**
     * Tests if elements contained in a Stack <code>stack</code>
     * is valid for the <code>Rhs</code>.
     * This mehtod is supposed to be used internally
     * by the Relaxer system.
     *
     * @param stack
     * @return boolean
     */
    public static boolean isMatch(RStack stack) {
        Element element = stack.peekElement();
        if (element == null) {
            return (false);
        }
        return (isMatch(element));
    }

    /**
     * Tests if elements contained in a Stack <code>stack</code>
     * is valid for the <code>Rhs</code>.
     * This method consumes the stack contents during matching operation.
     * This mehtod is supposed to be used internally
     * by the Relaxer system.
     *
     * @param stack
     * @return boolean
     */
    public static boolean isMatchHungry(RStack stack) {
        Element element = stack.peekElement();
        if (element == null) {
            return (false);
        }
        if (isMatch(element)) {
            stack.popElement();
            return (true);
        } else {
            return (false);
        }
    }
}
