package relaxer.vxml20;

import java.io.*;
import java.io.IOException;
import java.io.PrintWriter;
import java.io.Writer;
import java.net.URL;
import javax.xml.parsers.*;
import org.w3c.dom.*;
import org.xml.sax.*;

/**
 * <b>GramItem</b> is generated from vxml20.rxg by Relaxer.
 * This class is derived from:
 * 
 * <!-- for programmer
 * <elementRule role="item">
 *   <mixed>
 *     <choice occurs="*">
 *       <ref label="token"/>
 *       <ref label="ruleref"/>
 *       <ref label="item"/>
 *       <ref label="one-of"/>
 *       <ref label="tag"/>
 *     </choice>
 *   </mixed>
 * </elementRule>
 * 
 * <tag name="item">
 *   <attribute name="repeat" type="NMTOKEN"/>
 *   <attribute name="repeat-prob" type="NMTOKEN"/>
 *   <attribute name="weight" type="NMTOKEN"/>
 * </tag>
 * -->
 * <!-- for javadoc -->
 * <pre> &lt;elementRule role="item"&gt;
 *   &lt;mixed&gt;
 *     &lt;choice occurs="*"&gt;
 *       &lt;ref label="token"/&gt;
 *       &lt;ref label="ruleref"/&gt;
 *       &lt;ref label="item"/&gt;
 *       &lt;ref label="one-of"/&gt;
 *       &lt;ref label="tag"/&gt;
 *     &lt;/choice&gt;
 *   &lt;/mixed&gt;
 * &lt;/elementRule&gt;
 * &lt;tag name="item"&gt;
 *   &lt;attribute name="repeat" type="NMTOKEN"/&gt;
 *   &lt;attribute name="repeat-prob" type="NMTOKEN"/&gt;
 *   &lt;attribute name="weight" type="NMTOKEN"/&gt;
 * &lt;/tag&gt;
 * </pre>
 *
 * @version vxml20.rxg (Thu Aug 14 17:30:01 JST 2003)
 * @author  Relaxer 1.0rc3b (http://www.relaxer.org)
 */
public class GramItem implements java.io.Serializable, Cloneable, IRNSContainer, IGramItemMixed, IGramItemMixedChoice, IRVisitable, IRNode, IGramRuleMixed, IGramRuleMixedChoice {
    private RNSContext rNSContext_ = new RNSContext(this, "http://hil.t.u-tokyo.ac.jp/XML/2002/SRGS");
    private String repeat_;
    private String repeatProb_;
    private String weight_;
    // List<IGramItemMixed>
    private java.util.List content_ = new java.util.ArrayList();
    private IRNode parentRNode_;

    /**
     * Creates a <code>GramItem</code>.
     *
     */
    public GramItem() {
    }

    /**
     * Creates a <code>GramItem</code>.
     *
     * @param source
     */
    public GramItem(GramItem source) {
        setup(source);
    }

    /**
     * Creates a <code>GramItem</code> by the Stack <code>stack</code>
     * that contains Elements.
     * This constructor is supposed to be used internally
     * by the Relaxer system.
     *
     * @param stack
     */
    public GramItem(RStack stack) {
        setup(stack);
    }

    /**
     * Creates a <code>GramItem</code> by the Document <code>doc</code>.
     *
     * @param doc
     */
    public GramItem(Document doc) {
        setup(doc.getDocumentElement());
    }

    /**
     * Creates a <code>GramItem</code> by the Element <code>element</code>.
     *
     * @param element
     */
    public GramItem(Element element) {
        setup(element);
    }

    /**
     * Creates a <code>GramItem</code> by the File <code>file</code>.
     *
     * @param file
     * @exception IOException
     * @exception SAXException
     * @exception ParserConfigurationException
     */
    public GramItem(File file) throws IOException, SAXException, ParserConfigurationException {
        setup(file);
    }

    /**
     * Creates a <code>GramItem</code>
     * by the String representation of URI <code>uri</code>.
     *
     * @param uri
     * @exception IOException
     * @exception SAXException
     * @exception ParserConfigurationException
     */
    public GramItem(String uri) throws IOException, SAXException, ParserConfigurationException {
        setup(uri);
    }

    /**
     * Creates a <code>GramItem</code> by the URL <code>url</code>.
     *
     * @param url
     * @exception IOException
     * @exception SAXException
     * @exception ParserConfigurationException
     */
    public GramItem(URL url) throws IOException, SAXException, ParserConfigurationException {
        setup(url);
    }

    /**
     * Creates a <code>GramItem</code> by the InputStream <code>in</code>.
     *
     * @param in
     * @exception IOException
     * @exception SAXException
     * @exception ParserConfigurationException
     */
    public GramItem(InputStream in) throws IOException, SAXException, ParserConfigurationException {
        setup(in);
    }

    /**
     * Creates a <code>GramItem</code> by the InputSource <code>is</code>.
     *
     * @param is
     * @exception IOException
     * @exception SAXException
     * @exception ParserConfigurationException
     */
    public GramItem(InputSource is) throws IOException, SAXException, ParserConfigurationException {
        setup(is);
    }

    /**
     * Creates a <code>GramItem</code> by the Reader <code>reader</code>.
     *
     * @param reader
     * @exception IOException
     * @exception SAXException
     * @exception ParserConfigurationException
     */
    public GramItem(Reader reader) throws IOException, SAXException, ParserConfigurationException {
        setup(reader);
    }

    /**
     * Initializes the <code>GramItem</code> by the GramItem <code>source</code>.
     *
     * @param source
     */
    public void setup(GramItem source) {
        int size;
        setRepeat(source.getRepeat());
        setRepeatProb(source.getRepeatProb());
        setWeight(source.getWeight());
        this.content_.clear();
        size = source.content_.size();
        for (int i = 0;i < size;i++) {
            addContent((IGramItemMixed)source.getContent(i).clone());
        }
    }

    /**
     * Initializes the <code>GramItem</code> by the Document <code>doc</code>.
     *
     * @param doc
     */
    public void setup(Document doc) {
        setup(doc.getDocumentElement());
    }

    /**
     * Initializes the <code>GramItem</code> by the Element <code>element</code>.
     *
     * @param element
     */
    public void setup(Element element) {
        init(element);
    }

    /**
     * Initializes the <code>GramItem</code> by the Stack <code>stack</code>
     * that contains Elements.
     * This constructor is supposed to be used internally
     * by the Relaxer system.
     *
     * @param stack
     */
    public void setup(RStack stack) {
        init(stack.popElement());
    }

    /**
     * @param element
     */
    private void init(Element element) {
        RStack stack = new RStack(element);
        rNSContext_.declareNamespace(element);
        repeat_ = URelaxer.getAttributePropertyAsString(element, "repeat");
        repeatProb_ = URelaxer.getAttributePropertyAsString(element, "repeat-prob");
        weight_ = URelaxer.getAttributePropertyAsString(element, "weight");
        this.content_.clear();
        while (true) {
            if (RString.isMatch(stack)) {
                addContent(new RString(stack));
            } else if (GramRuleref.isMatch(stack)) {
                addContent(new GramRuleref(stack));
            } else if (GramItem.isMatch(stack)) {
                addContent(new GramItem(stack));
            } else if (GramToken.isMatch(stack)) {
                addContent(new GramToken(stack));
            } else if (GramOneOf.isMatch(stack)) {
                addContent(new GramOneOf(stack));
            } else if (GramTag.isMatch(stack)) {
                addContent(new GramTag(stack));
            } else {
                break;
            }
        }
    }

    /**
     * @return Object
     */
    public Object clone() {
        return (new GramItem(this));
    }

    /**
     * Creates a DOM representation of the object.
     * Result is appended to the Node <code>parent</code>.
     *
     * @param parent
     */
    public void makeElement(Node parent) {
        Document doc;
        if (parent instanceof Document) {
            doc = (Document)parent;
        } else {
            doc = parent.getOwnerDocument();
        }
        Element element = doc.createElementNS("http://hil.t.u-tokyo.ac.jp/XML/2002/SRGS", "item");
        rNSContext_.setupNamespace(element);
        int size;
        if (this.repeat_ != null) {
            URelaxer.setAttributePropertyByString(element, "repeat", this.repeat_);
        }
        if (this.repeatProb_ != null) {
            URelaxer.setAttributePropertyByString(element, "repeat-prob", this.repeatProb_);
        }
        if (this.weight_ != null) {
            URelaxer.setAttributePropertyByString(element, "weight", this.weight_);
        }
        size = this.content_.size();
        for (int i = 0;i < size;i++) {
            IGramItemMixed value = (IGramItemMixed)this.content_.get(i);
            value.makeElement(element);
        }
        parent.appendChild(element);
    }

    /**
     * Initializes the <code>GramItem</code> by the File <code>file</code>.
     *
     * @param file
     * @exception IOException
     * @exception SAXException
     * @exception ParserConfigurationException
     */
    public void setup(File file) throws IOException, SAXException, ParserConfigurationException {
        setup(file.toURL());
    }

    /**
     * Initializes the <code>GramItem</code>
     * by the String representation of URI <code>uri</code>.
     *
     * @param uri
     * @exception IOException
     * @exception SAXException
     * @exception ParserConfigurationException
     */
    public void setup(String uri) throws IOException, SAXException, ParserConfigurationException {
        setup(UJAXP.getDocument(uri, UJAXP.FLAG_NAMESPACE_AWARE));
    }

    /**
     * Initializes the <code>GramItem</code> by the URL <code>url</code>.
     *
     * @param url
     * @exception IOException
     * @exception SAXException
     * @exception ParserConfigurationException
     */
    public void setup(URL url) throws IOException, SAXException, ParserConfigurationException {
        setup(UJAXP.getDocument(url, UJAXP.FLAG_NAMESPACE_AWARE));
    }

    /**
     * Initializes the <code>GramItem</code> by the InputStream <code>in</code>.
     *
     * @param in
     * @exception IOException
     * @exception SAXException
     * @exception ParserConfigurationException
     */
    public void setup(InputStream in) throws IOException, SAXException, ParserConfigurationException {
        setup(UJAXP.getDocument(in, UJAXP.FLAG_NAMESPACE_AWARE));
    }

    /**
     * Initializes the <code>GramItem</code> by the InputSource <code>is</code>.
     *
     * @param is
     * @exception IOException
     * @exception SAXException
     * @exception ParserConfigurationException
     */
    public void setup(InputSource is) throws IOException, SAXException, ParserConfigurationException {
        setup(UJAXP.getDocument(is, UJAXP.FLAG_NAMESPACE_AWARE));
    }

    /**
     * Initializes the <code>GramItem</code> by the Reader <code>reader</code>.
     *
     * @param reader
     * @exception IOException
     * @exception SAXException
     * @exception ParserConfigurationException
     */
    public void setup(Reader reader) throws IOException, SAXException, ParserConfigurationException {
        setup(UJAXP.getDocument(reader, UJAXP.FLAG_NAMESPACE_AWARE));
    }

    /**
     * Creates a DOM document representation of the object.
     *
     * @exception ParserConfigurationException
     * @return Document
     */
    public Document makeDocument() throws ParserConfigurationException {
        Document doc = UJAXP.makeDocument();
        makeElement(doc);
        return (doc);
    }

    /**
     * Sets a mixed content by <code>String</code>.
     *
     * @param text
     */
    public void setContent(String text) {
        setContent(new RString(text));
    }

    /**
     * Sets a mixed content by <code>String</code>.
     *
     * @param text
     */
    public void setContentByString(String text) {
        setContent(new RString(text));
    }

    /**
     * Gets the RNSContext property <b>RNSContext</b>.
     *
     * @return RNSContext
     */
    public final RNSContext rGetRNSContext() {
        return (rNSContext_);
    }

    /**
     * Sets the RNSContext property <b>RNSContext</b>.
     *
     * @param rNSContext
     */
    public final void rSetRNSContext(RNSContext rNSContext) {
        this.rNSContext_ = rNSContext;
    }

    /**
     * Gets the String property <b>repeat</b>.
     *
     * @return String
     */
    public final String getRepeat() {
        return (repeat_);
    }

    /**
     * Sets the String property <b>repeat</b>.
     *
     * @param repeat
     */
    public final void setRepeat(String repeat) {
        this.repeat_ = repeat;
    }

    /**
     * Gets the String property <b>repeatProb</b>.
     *
     * @return String
     */
    public final String getRepeatProb() {
        return (repeatProb_);
    }

    /**
     * Sets the String property <b>repeatProb</b>.
     *
     * @param repeatProb
     */
    public final void setRepeatProb(String repeatProb) {
        this.repeatProb_ = repeatProb;
    }

    /**
     * Gets the String property <b>weight</b>.
     *
     * @return String
     */
    public final String getWeight() {
        return (weight_);
    }

    /**
     * Sets the String property <b>weight</b>.
     *
     * @param weight
     */
    public final void setWeight(String weight) {
        this.weight_ = weight;
    }

    /**
     * Gets the IGramItemMixed property <b>content</b>.
     *
     * @return IGramItemMixed[]
     */
    public final IGramItemMixed[] getContent() {
        IGramItemMixed[] array = new IGramItemMixed[content_.size()];
        return ((IGramItemMixed[])content_.toArray(array));
    }

    /**
     * Sets the IGramItemMixed property <b>content</b>.
     *
     * @param content
     */
    public final void setContent(IGramItemMixed[] content) {
        this.content_.clear();
        for (int i = 0;i < content.length;i++) {
            addContent(content[i]);
        }
        for (int i = 0;i < content.length;i++) {
            content[i].rSetParentRNode(this);
        }
    }

    /**
     * Sets the IGramItemMixed property <b>content</b>.
     *
     * @param content
     */
    public final void setContent(IGramItemMixed content) {
        this.content_.clear();
        addContent(content);
        if (content != null) {
            content.rSetParentRNode(this);
        }
    }

    /**
     * Adds the IGramItemMixed property <b>content</b>.
     *
     * @param content
     */
    public final void addContent(IGramItemMixed content) {
        this.content_.add(content);
        if (content != null) {
            content.rSetParentRNode(this);
        }
    }

    /**
     * Adds the IGramItemMixed property <b>content</b>.
     *
     * @param content
     */
    public final void addContent(IGramItemMixed[] content) {
        for (int i = 0;i < content.length;i++) {
            addContent(content[i]);
        }
        for (int i = 0;i < content.length;i++) {
            content[i].rSetParentRNode(this);
        }
    }

    /**
     * Gets number of the IGramItemMixed property <b>content</b>.
     *
     * @return int
     */
    public final int sizeContent() {
        return (content_.size());
    }

    /**
     * Gets the IGramItemMixed property <b>content</b> by index.
     *
     * @param index
     * @return IGramItemMixed
     */
    public final IGramItemMixed getContent(int index) {
        return ((IGramItemMixed)content_.get(index));
    }

    /**
     * Sets the IGramItemMixed property <b>content</b> by index.
     *
     * @param index
     * @param content
     */
    public final void setContent(int index, IGramItemMixed content) {
        this.content_.set(index, content);
        if (content != null) {
            content.rSetParentRNode(this);
        }
    }

    /**
     * Adds the IGramItemMixed property <b>content</b> by index.
     *
     * @param index
     * @param content
     */
    public final void addContent(int index, IGramItemMixed content) {
        this.content_.add(index, content);
        if (content != null) {
            content.rSetParentRNode(this);
        }
    }

    /**
     * Remove the IGramItemMixed property <b>content</b> by index.
     *
     * @param index
     */
    public final void removeContent(int index) {
        this.content_.remove(index);
    }

    /**
     * Remove the IGramItemMixed property <b>content</b> by object.
     *
     * @param content
     */
    public final void removeContent(IGramItemMixed content) {
        this.content_.remove(content);
    }

    /**
     * Clear the IGramItemMixed property <b>content</b>.
     *
     */
    public final void clearContent() {
        this.content_.clear();
    }

    /**
     * Makes an XML text representation.
     *
     * @return String
     */
    public String makeTextDocument() {
        StringBuffer buffer = new StringBuffer();
        makeTextElement(buffer);
        return (new String(buffer));
    }

    /**
     * Makes an XML text representation.
     *
     * @param buffer
     */
    public void makeTextElement(StringBuffer buffer) {
        int size;
        String prefix = rNSContext_.getPrefixByUri("http://hil.t.u-tokyo.ac.jp/XML/2002/SRGS");
        buffer.append("<");
        URelaxer.makeQName(prefix, "item", buffer);
        rNSContext_.makeNSMappings(buffer);
        if (repeat_ != null) {
            buffer.append(" ");
            buffer.append("repeat");
            buffer.append("=\"");
            buffer.append(URelaxer.escapeAttrQuot(URelaxer.getString(getRepeat())));
            buffer.append("\"");
        }
        if (repeatProb_ != null) {
            buffer.append(" ");
            buffer.append("repeat-prob");
            buffer.append("=\"");
            buffer.append(URelaxer.escapeAttrQuot(URelaxer.getString(getRepeatProb())));
            buffer.append("\"");
        }
        if (weight_ != null) {
            buffer.append(" ");
            buffer.append("weight");
            buffer.append("=\"");
            buffer.append(URelaxer.escapeAttrQuot(URelaxer.getString(getWeight())));
            buffer.append("\"");
        }
        size = this.content_.size();
        for (int i = 0;i < size;i++) {
            IGramItemMixed value = (IGramItemMixed)this.content_.get(i);
            value.makeTextAttribute(buffer);
        }
        buffer.append(">");
        size = this.content_.size();
        for (int i = 0;i < size;i++) {
            IGramItemMixed value = (IGramItemMixed)this.content_.get(i);
            value.makeTextElement(buffer);
        }
        buffer.append("</");
        URelaxer.makeQName(prefix, "item", buffer);
        buffer.append(">");
    }

    /**
     * Makes an XML text representation.
     *
     * @param buffer
     * @exception IOException
     */
    public void makeTextElement(Writer buffer) throws IOException {
        int size;
        String prefix = rNSContext_.getPrefixByUri("http://hil.t.u-tokyo.ac.jp/XML/2002/SRGS");
        buffer.write("<");
        URelaxer.makeQName(prefix, "item", buffer);
        rNSContext_.makeNSMappings(buffer);
        if (repeat_ != null) {
            buffer.write(" ");
            buffer.write("repeat");
            buffer.write("=\"");
            buffer.write(URelaxer.escapeAttrQuot(URelaxer.getString(getRepeat())));
            buffer.write("\"");
        }
        if (repeatProb_ != null) {
            buffer.write(" ");
            buffer.write("repeat-prob");
            buffer.write("=\"");
            buffer.write(URelaxer.escapeAttrQuot(URelaxer.getString(getRepeatProb())));
            buffer.write("\"");
        }
        if (weight_ != null) {
            buffer.write(" ");
            buffer.write("weight");
            buffer.write("=\"");
            buffer.write(URelaxer.escapeAttrQuot(URelaxer.getString(getWeight())));
            buffer.write("\"");
        }
        size = this.content_.size();
        for (int i = 0;i < size;i++) {
            IGramItemMixed value = (IGramItemMixed)this.content_.get(i);
            value.makeTextAttribute(buffer);
        }
        buffer.write(">");
        size = this.content_.size();
        for (int i = 0;i < size;i++) {
            IGramItemMixed value = (IGramItemMixed)this.content_.get(i);
            value.makeTextElement(buffer);
        }
        buffer.write("</");
        URelaxer.makeQName(prefix, "item", buffer);
        buffer.write(">");
    }

    /**
     * Makes an XML text representation.
     *
     * @param buffer
     */
    public void makeTextElement(PrintWriter buffer) {
        int size;
        String prefix = rNSContext_.getPrefixByUri("http://hil.t.u-tokyo.ac.jp/XML/2002/SRGS");
        buffer.print("<");
        URelaxer.makeQName(prefix, "item", buffer);
        rNSContext_.makeNSMappings(buffer);
        if (repeat_ != null) {
            buffer.print(" ");
            buffer.print("repeat");
            buffer.print("=\"");
            buffer.print(URelaxer.escapeAttrQuot(URelaxer.getString(getRepeat())));
            buffer.print("\"");
        }
        if (repeatProb_ != null) {
            buffer.print(" ");
            buffer.print("repeat-prob");
            buffer.print("=\"");
            buffer.print(URelaxer.escapeAttrQuot(URelaxer.getString(getRepeatProb())));
            buffer.print("\"");
        }
        if (weight_ != null) {
            buffer.print(" ");
            buffer.print("weight");
            buffer.print("=\"");
            buffer.print(URelaxer.escapeAttrQuot(URelaxer.getString(getWeight())));
            buffer.print("\"");
        }
        size = this.content_.size();
        for (int i = 0;i < size;i++) {
            IGramItemMixed value = (IGramItemMixed)this.content_.get(i);
            value.makeTextAttribute(buffer);
        }
        buffer.print(">");
        size = this.content_.size();
        for (int i = 0;i < size;i++) {
            IGramItemMixed value = (IGramItemMixed)this.content_.get(i);
            value.makeTextElement(buffer);
        }
        buffer.print("</");
        URelaxer.makeQName(prefix, "item", buffer);
        buffer.print(">");
    }

    /**
     * Makes an XML text representation.
     *
     * @param buffer
     */
    public void makeTextAttribute(StringBuffer buffer) {
    }

    /**
     * Makes an XML text representation.
     *
     * @param buffer
     * @exception IOException
     */
    public void makeTextAttribute(Writer buffer) throws IOException {
    }

    /**
     * Makes an XML text representation.
     *
     * @param buffer
     */
    public void makeTextAttribute(PrintWriter buffer) {
    }

    /**
     * Gets the property value as String.
     *
     * @return String
     */
    public String getRepeatAsString() {
        return (URelaxer.getString(getRepeat()));
    }

    /**
     * Gets the property value as String.
     *
     * @return String
     */
    public String getRepeatProbAsString() {
        return (URelaxer.getString(getRepeatProb()));
    }

    /**
     * Gets the property value as String.
     *
     * @return String
     */
    public String getWeightAsString() {
        return (URelaxer.getString(getWeight()));
    }

    /**
     * Sets the property value by String.
     *
     * @param string
     */
    public void setRepeatByString(String string) {
        setRepeat(string);
    }

    /**
     * Sets the property value by String.
     *
     * @param string
     */
    public void setRepeatProbByString(String string) {
        setRepeatProb(string);
    }

    /**
     * Sets the property value by String.
     *
     * @param string
     */
    public void setWeightByString(String string) {
        setWeight(string);
    }

    /**
     * Returns a String representation of this object.
     * While this method informs as XML format representaion, 
     *  it's purpose is just information, not making 
     * a rigid XML documentation.
     *
     * @return String
     */
    public String toString() {
        try {
            return (makeTextDocument());
        } catch (Exception e) {
            return (super.toString());
        }
    }

    /**
     * Accepts the Visitor for enter behavior.
     *
     * @param visitor
     * @return boolean
     */
    public boolean enter(IRVisitor visitor) {
        return (visitor.enter(this));
    }

    /**
     * Accepts the Visitor for leave behavior.
     *
     * @param visitor
     */
    public void leave(IRVisitor visitor) {
        visitor.leave(this);
    }

    /**
     * Gets the IRNode property <b>parentRNode</b>.
     *
     * @return IRNode
     */
    public final IRNode rGetParentRNode() {
        return (parentRNode_);
    }

    /**
     * Sets the IRNode property <b>parentRNode</b>.
     *
     * @param parentRNode
     */
    public final void rSetParentRNode(IRNode parentRNode) {
        this.parentRNode_ = parentRNode;
    }

    /**
     * Gets child RNodes.
     *
     * @return IRNode[]
     */
    public IRNode[] rGetRNodes() {
        java.util.List classNodes = new java.util.ArrayList();
        classNodes.addAll(content_);
        IRNode[] nodes = new IRNode[classNodes.size()];
        return ((IRNode[])classNodes.toArray(nodes));
    }

    /**
     * Tests if a Element <code>element</code> is valid
     * for the <code>GramItem</code>.
     *
     * @param element
     * @return boolean
     */
    public static boolean isMatch(Element element) {
        if (!URelaxer2.isTargetElement(element, "http://hil.t.u-tokyo.ac.jp/XML/2002/SRGS", "item")) {
            return (false);
        }
        RStack target = new RStack(element);
        boolean $match$ = false;
        Element child;
        while (true) {
            if (GramRuleref.isMatchHungry(target)) {
                $match$ = true;
            } else if (GramItem.isMatchHungry(target)) {
                $match$ = true;
            } else if (GramToken.isMatchHungry(target)) {
                $match$ = true;
            } else if (GramOneOf.isMatchHungry(target)) {
                $match$ = true;
            } else if (GramTag.isMatchHungry(target)) {
                $match$ = true;
            } else {
                break;
            }
        }
        if (!target.isEmptyElement()) {
            return (false);
        }
        return (true);
    }

    /**
     * Tests if elements contained in a Stack <code>stack</code>
     * is valid for the <code>GramItem</code>.
     * This mehtod is supposed to be used internally
     * by the Relaxer system.
     *
     * @param stack
     * @return boolean
     */
    public static boolean isMatch(RStack stack) {
        Element element = stack.peekElement();
        if (element == null) {
            return (false);
        }
        return (isMatch(element));
    }

    /**
     * Tests if elements contained in a Stack <code>stack</code>
     * is valid for the <code>GramItem</code>.
     * This method consumes the stack contents during matching operation.
     * This mehtod is supposed to be used internally
     * by the Relaxer system.
     *
     * @param stack
     * @return boolean
     */
    public static boolean isMatchHungry(RStack stack) {
        Element element = stack.peekElement();
        if (element == null) {
            return (false);
        }
        if (isMatch(element)) {
            stack.popElement();
            return (true);
        } else {
            return (false);
        }
    }
}
