/*++
Cofiguration.h
--*/
#ifndef __CONFIGURATION_H__
#define __CONFIGURATION_H__

#ifdef WIN32
#pragma warning (disable: 4786)
#endif

#include <iostream>
#include <string>
#include <vector>

#include <stdio.h>

#include "Resources.h"

#define DEF_MASKFILE	"MaskFile"
#define DEF_MASKEYE		"MaskEye"
#define DEF_MASKTEETH	"MaskTeeth"
#define DEF_BGFILE		"BackgroundFile"
#define DEF_AUTONOMOUS_BLINK	"AutonomousBlink"
#define DEF_AUTONOMOUS_MOVE		"AutonomousMove"
#define DEF_AUTONOMOUS_USERDEF	"AutonomousUserdef"
#define DEF_FACEMOT_NOD		"FaceMotNod"
#define DEF_FACEMOT_LISTEN	"FaceMotListen"
#define DEF_FACEMOT_REFUSE	"FaceMotRefuse"
#define DEF_FACEMOT_USERDEF	"FaceMotUserDef"
#define DEF_FACEMOT_BLINK	"FaceMotBlink"
#define DEF_MAX_FRAME_RATE	"MaxFrameRate"

#define BLINK_STR		"set Face.30 = "

using namespace std;

const int DEFALUT_MAX_FPS = 30;

class Configuration { 
private:
	// 
	vector<string> m_vsMaskName;    // ̾
	vector<string> m_vsMaskRgbFile; // Imageե
	vector<string> m_vsMaskPntFile; // pntե
	vector<string> m_vsMaskEyeName;			// ̾
	vector<string> m_vsMaskEyeImageFile;	// Imageե
	vector<string> m_vsMaskEyeDefFile;		// ե
	vector<string> m_vsMaskTeethName;		// ̾
	vector<string> m_vsMaskTeethDefFile;	// λե

	// ط
	vector<string> m_vsBGName;    // طʤ̾
	vector<string> m_vsBGRgbFile; // طʤImageե

	vector<string> m_vsToken;       // ȡ
	
	// AutonomousϢ
	// Autonomous MOVE Ƭư
	vector< vector<int> > m_viAutonomousMove_frame;
	vector< vector<float> > m_vfAutonomousMove_x;
	vector< vector<float> > m_vfAutonomousMove_y;
	vector< vector<float> > m_vfAutonomousMove_z;
	int m_iAutonomousMove;

	// Autonomous MOVE 桼Ƭư
	vector< vector<int> > m_viAutonomousUserDef_frame;
	vector< vector<float> > m_vfAutonomousUserDef_x;
	vector< vector<float> > m_vfAutonomousUserDef_y;
	vector< vector<float> > m_vfAutonomousUserDef_z;
	int m_iAutonomousUserDef;

	// Autonomous Blink ֤
	vector<int> m_viAutonomousBlink;
	vector<int> m_viAutonomousBlinkPattern;

	// FaceMotϢ
	vector< vector<int> > m_viFaceMotNod_frame;
	vector< vector<float> > m_vfFaceMotNod_x;
	vector< vector<float> > m_vfFaceMotNod_y;
	vector< vector<float> > m_vfFaceMotNod_z;
	int m_iFaceMotNod;
	vector< vector<int> > m_viFaceMotRefuse_frame;
	vector< vector<float> > m_vfFaceMotRefuse_x;
	vector< vector<float> > m_vfFaceMotRefuse_y;
	vector< vector<float> > m_vfFaceMotRefuse_z;
	int m_iFaceMotRefuse;
	vector< vector<int> > m_viFaceMotListen_frame;
	vector< vector<float> > m_vfFaceMotListen_x;
	vector< vector<float> > m_vfFaceMotListen_y;
	vector< vector<float> > m_vfFaceMotListen_z;
	int m_iFaceMotListen;
	vector< vector<int> > m_viFaceMotUserDef_frame;
	vector< vector<float> > m_vfFaceMotUserDef_x;
	vector< vector<float> > m_vfFaceMotUserDef_y;
	vector< vector<float> > m_vfFaceMotUserDef_z;
	int m_iFaceMotUserDef;
	
	float m_fFaceMotAngle[3];
	float m_fAutonomousMoveAngle[3];
	
	vector< vector<int> > m_viFaceMotBlink;
	int m_iFaceMotBlink;

	// Frame RateϢ
	int m_iMaxFrameRate;

	bool OpenAutonomousMoveFile(string buffer, int num);
	bool OpenFaceMotFile(string buffer, int num);
	bool OpenFaceMotBlinkFile( int frame_num );
	void SplitToken(string buffer);
	
public:
	// public constructor
	Configuration(string configFile);
	
	// public destructor
	~Configuration();
	
	int GetMaskNum() { return m_vsMaskName.size(); }
	string GetMaskName(int i) { return m_vsMaskName[i]; }
	string GetMaskRgbFile(int i) { return m_vsMaskRgbFile[i]; }
	string GetMaskPntFile(int i) { return m_vsMaskPntFile[i]; }

	int GetMaskEyeNum() { return m_vsMaskEyeName.size(); }
	string GetMaskEyeName(int i) { return m_vsMaskEyeName[i]; }
	string GetMaskEyeImageFile(int i) { return m_vsMaskEyeImageFile[i]; }
	string GetMaskEyeDefFile(int i) { return m_vsMaskEyeDefFile[i]; }
	
	int GetMaskTeethNum() { return m_vsMaskTeethName.size(); }
	string GetMaskTeethName(int i) { return m_vsMaskTeethName[i]; }
	string GetMaskTeethDefFile(int i) { return m_vsMaskTeethDefFile[i]; }

	int GetBGNum() { return m_vsBGName.size(); }
	string GetBGName(int i) { return m_vsBGName[i]; }
	string GetBGRgbFile(int i) { return m_vsBGRgbFile[i]; }

	// Autonomous Blink
	int GetAutonomousBlinkNum() { return m_viAutonomousBlink.size(); }
	int GetAutonomousBlink(int i) { return m_viAutonomousBlink[i]; }
	int GetAutonomousBlinkPattern(int i) { return m_viAutonomousBlinkPattern[i]; }

	// AutonomousMov
	int GetAutonomousMoveSize(int mode);
	int GetAutonomousMoveFrameSize(int mode, int id);
	void GetAutonomousMoveCurrentFrame(int mode, int id, int frame);

	float GetAutonomousMoveAngle(int i) { return m_fAutonomousMoveAngle[i]; }
	void ResetAutonomousMoveFrame() {
		m_fAutonomousMoveAngle[0] = 0.0;
		m_fAutonomousMoveAngle[1] = 0.0;
		m_fAutonomousMoveAngle[2] = 0.0;
	}

	// FaceMot
	int GetFaceMotSize(int mode);
	int GetFaceMotFrameSize(int mode, int id);
	void GetFaceMotCurrentFrame(int mode, int id, int frame);

	float GetFaceMotAngle(int i) { return m_fFaceMotAngle[i]; }
	void ResetFaceMotFrame() {
		m_fFaceMotAngle[0] = 0.0;
		m_fFaceMotAngle[1] = 0.0;
		m_fFaceMotAngle[2] = 0.0;
	}

	int GetFaceMotBlinkSize() { return m_iFaceMotBlink; }
	int GetFaceMotBlinkStrSize(int i) {
		return m_viFaceMotBlink[i].size();
	}
	string GetFaceMotBlinkStr(int i, int j) {
		char temp[256];
		sprintf( temp, "%d", m_viFaceMotBlink[i][j] );
		string out_str(BLINK_STR);
		out_str += temp;
		return out_str;
	}

	int GetFrameRate() { return m_iMaxFrameRate; }
	void SetFrameRate(int i) { m_iMaxFrameRate = i; }
};

#endif

