// Sock.cpp: CSock 饹Υץơ
//
//////////////////////////////////////////////////////////////////////


#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

#include "Sock.h"

#ifdef WIN32
#include <windows.h>
#endif

#include <stdio.h>

//////////////////////////////////////////////////////////////////////
// /
//////////////////////////////////////////////////////////////////////

//
// ̾		:CSock::CSock()
// ǽ		:ǥեȥ󥹥ȥ饯
// 		:ʤ
// 	:ʤ
//
CSock::CSock()
{
	m_hSocket = INVALID_SOCKET;
	InitializeCriticalSection( &m_CriticalSection );
}

//
// ̾		:CSock::~CSock()
// ǽ		:ǥȥ饯
// 		:ʤ
// 	:ʤ
//
CSock::~CSock()
{
}

/*
//
// ̾		:void CSock::Attach( SOCKET hSocket )
// ǽ		:åȥϥɥϢդ
// 		:hSocket - åȥϥɥ
// 	:ʤ
//
void CSock::Attach( SOCKET hSocket )
{
	m_hSocket = hSocket;
}

//
// ̾		:void CSock::Detach()
// ǽ		:ФΥåȥϥɥĤ
// 		:ʤ
// 	:ʤ
//
void CSock::Detach()
{
	if( m_hSocket != INVALID_SOCKET )
	{
		shutdown( m_hSocket, 0x02 );
		closesocket( m_hSocket );
		m_hSocket = INVALID_SOCKET;
	}
}
*/

//
// ̾		:bool CSock::Socket( int nAddrFamily, int nSocketType, int nProtocol )
// ǽ		:åȥϥɥ
// 		:nAddrFamily - ɥ쥹եߥ
//			:nSocketType - åȤμ
//			:nProtocol - ץȥ
// 	: - true Ի - false
//
bool CSock::Socket( int nAddrFamily, int nSocketType, int nProtocol )
{
	m_hSocket = socket( nAddrFamily, nSocketType, nProtocol );
	if( m_hSocket == INVALID_SOCKET ){return false;}
	return true;
}

//
// ̾		:bool CSock::Bind( CSockAddr *addr )
// ǽ		:åȤΥɥ쥹˥Хɤ
// 		:*addr - Хɤ륢ɥ쥹ݻ󥹥󥹤Υݥ
// 	: - true Ի - false
//
bool CSock::Bind(int nPort )
{
//	this->m_InetSockAddrFrom.sin_addr.s_addr = inet_addr( lpszIP );
	this->m_InetSockAddrTo.sin_addr.s_addr = htonl(INADDR_ANY);
	this->m_InetSockAddrFrom.sin_port = htons( (u_short)nPort );
	this->m_InetSockAddrFrom.sin_family = AF_INET;

	if( m_hSocket == INVALID_SOCKET ){return false;}

	if( bind( m_hSocket, (struct sockaddr*)&m_InetSockAddrFrom, sizeof( sockaddr_in ) ) == SOCKET_ERROR )
		return false;
	return true;
}

//
// ̾		:bool CSock::Listen( int nMaxCon )
// ǽ		:åȤΥɥ쥹˥Хɤ
// 		:*addr - Хɤ륢ɥ쥹ݻ󥹥󥹤Υݥ
// 	: - true Ի - false
//
bool CSock::Listen( int nMaxCon )
{
	if( m_hSocket == INVALID_SOCKET ||
		nMaxCon < 1
		){return false;}

	if( listen( m_hSocket, nMaxCon ) == SOCKET_ERROR )
		return false;
	return true;
}

//
// ̾		:bool CSock::Accept()
// ǽ		:ΥåȤ³׵Υץ
// 		:&sock - ץѤΥå
// 	: - TRUE Ի - FALSE
//
bool CSock::Accept()
{
	if( m_hSocket == INVALID_SOCKET ){return false;}

	printf("FSM Server mode. waiting...\n");

	int nSize = sizeof( sockaddr );
	m_hClientSocket = accept( m_hSocket, NULL, &nSize );

	printf("conected\n");

	return true;
}

/*
//
// ̾		:bool CSock::Connect( CSockAddr *addr )
// ǽ		:Υɥ쥹³
// 		:*addr - ³륢ɥ쥹ݻ󥹥󥹤Υݥ
// 	: - true Ի - false
//
bool CSock::Connect( LPCTSTR lpszIP, int nPort )
{
	this->m_InetSockAddrTo.sin_addr.s_addr = inet_addr( lpszIP );
	this->m_InetSockAddrTo.sin_port = htons( (u_short)nPort );
	this->m_InetSockAddrTo.sin_family = AF_INET;

	if( m_hSocket == INVALID_SOCKET ){return false;}

	if( connect( m_hSocket, (struct sockaddr*)&m_InetSockAddrTo, sizeof( sockaddr_in ) ) == SOCKET_ERROR )
		return false;
	return true;
}
*/

//
// ̾		:void CSock::Close()
// ǽ		:ФΥåȥϥɥĤ
// 		:
// 	:
//
void CSock::Close()
{
	shutdown( m_hClientSocket, 0x02 );
	closesocket( m_hClientSocket );
	m_hClientSocket = INVALID_SOCKET;

	shutdown( m_hSocket, 0x02 );
	closesocket( m_hSocket );
	m_hSocket = INVALID_SOCKET;
}

//
// ̾		:int CSock::Send( const char *szMsg, int nByte )
// ǽ		:sMsgnByteХ
// 		:sMsg - ХåեΥݥ
//			:nByte - Хȿ
// 	:ºݤ줿Хȿ
//
int CSock::Send( const char *szMsg, size_t nByte )
{
	if( m_hClientSocket == INVALID_SOCKET ){return 0;}
	return send( m_hClientSocket, szMsg, nByte, 0 );
}

//
// ̾		:int CSock::Recv( char *szBuff )
// ǽ		:ơsBuff˳Ǽ
// 		:szBuff - ѥХåեΥݥ
// 	:Хȿ
//
int CSock::Recv( char *szBuff )
{
	if( m_hClientSocket == INVALID_SOCKET ){return 0;}
	return recv( m_hClientSocket, szBuff, RECV_BUFFER_SIZE, 0 );
}

//
// ̾		:bool CSock::Detach()
// ǽ		:ФΥåȥϥɥ뤬ͭĴ٤
// 		:
// 	:ͭ - true ̵ - false
//
bool CSock::IsValid()
{
	if( m_hSocket == INVALID_SOCKET ){return false;}
	return true;
}
