/* Copyright (c) 2000-2003                             */
/*   Takao Kobayashi, Takashi Masuko, Masatsune Tamura */
/*   Tokyo Institute of Technology                     */
/*   Keiichi Tokuda, Takayoshi Yoshimura, Heiga Zen    */
/*   Nagoya Institute of Technology                    */
/*   All rights reserved                               */

/************************************************************************
*									*
*    Model reading functions						*
*									*
*					2000.5 M.Tamura			*
*									*
************************************************************************/

typedef struct _Model {
  char *name;
  char *durpdf;
  char **pitchpdf;
  char **mceppdf;
  int *duration;
  int totalduration;
  float *durmean;
  float *durvariance;
  float **pitchmean;
  float **pitchvariance;
  float **mcepmean;
  float **mcepvariance;
  Boolean *voiced;
  PHONEME *phoneme;
  struct _Model *next;
} Model;

Model *mhead;
Model *mtail;

FILE *durmodel;
FILE *pitchmodel;
FILE *mcepmodel;

void ReadModelFile (int);
void SearchDurationPDF (Model *, int);
void SearchPitchPDF (Model *, int, int);
void SearchMcepPDF (Model *, int, int);

